'Compilable Example:
#Compile Exe  "gbrider.exe"
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

%Unicode = 1
#Include "Win32api.inc"
#Include "cgdiplus.inc"

#Resource Icon logo, "images\gbrider.ico"
#Resource Icon xnew, "images\new.ico"
#Resource Icon xreset, "images\reset.ico"
#Resource Icon xpower, "images\power.ico"
#Resource Icon xstep, "images\step.ico"
#Resource Icon xcopy, "images\copy.ico"
#Resource Icon xsettings, "images\settings.ico"
#Resource Icon xhelp, "images\help.ico"
#Resource Icon xopen, "images\open.ico"
#Resource Icon xsave, "images\save.ico"
#Resource Icon xzoom, "images\zoom.ico"

$Ver = "1.0"
$SessionImage = "images\session.bmp"
$SpriteImage  = "images\gbrider.png"

Type CustomColors
   c(15) As Long
End Type

Type Sprite
   bmp As Dword
   dc As Dword
   x As Long
   y As Long
   xvel As Long
   yvel As Long      'changes with each pixel move
   t As Single
   ts(5) As Single
   w As Long
   h As Long
End Type

Enum Equates Singular
   IDC_Toolbar
   IDC_Graphic

   IDT_New
   IDT_Open
   IDT_Save
   IDT_Reset
   IDT_Power
   IDT_Step
   IDT_Copy
   IDT_ZoomOut
   IDT_Settings
   IDT_Help

   ID_Timer

   IDM_BGColor
   IDM_TrackColor
   IDM_DefaultColors
   IDM_OutofSight
   IDM_AllowUnder
   IDM_Sep
End Enum

Global hDlg,hToolbar,hGraphic,hGraphicDC,hSettings,hFont,hBMPR,hDCR As Dword
Global LastX,LastY As Long, CustomColorList As CustomColors
Global RiderX, RiderY, BGColor, AllowUnder, SpriteColor, TrackColor,LineWidth, Ride,ZoomOut As Long
Global s As Sprite, track$, D(), TimerInterval,Power,Eraser,EraseWidth As Long, M$
Global OutOfSight, TrackW,TrackH,GraphicW,GraphicH As Long, FileName As WStringZ * %Max_Path
Global qFreq, qStart, qStop As Quad, CutOffX, CutOffY, Rule As Long
Global HSX(),HSY(),RW,RH As Long

Function PBMain() As Long
   Dialog New Pixels, 0, "gbRider   v" + $ver,300,300,400,400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hdlg, "logo"
   CreateToolbar
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local PTT As TooltipText Ptr, NMTB As TBNotify Ptr, rc As Rect
   Local iResult,x,y,i,j,w,h As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         BuildAcceleratorTable
         Font New "Tahoma",10,0 To hFont
         Control Set Font hDlg, %IDC_Toolbar, hFont
         If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
         If IsFolder (Exe.Path$ + "tracks") = %False Then MkDir Exe.Path$ + "tracks"
         ReDim HSX(20), HSY(20)   'history points not As Point so I can use Insert Array
         If IsFile($SpriteImage) Then
            LoadImageToMemoryBitmap $SpriteImage, s.bmp,s.w,s.h,s.DC    'background graphic
         Else
            s.w = 30 : s.h = 30
            Graphic Bitmap New s.w, s.h To s.BMP
            Graphic Attach s.BMP, 0
            Graphic Get DC To s.DC
            Graphic Color %Black, %Black
            Graphic Ellipse (5,5)-(25,25),%Green,%Green
         End If
         SetCutoffValues
         CreateRotationBitmap
         QueryPerformanceFrequency qFreq
         CreateGraphic
         If IsFile($SessionImage) Then LoadSessionImage
         Graphic Attach hDlg, %IDC_Graphic, ReDraw
         Graphic Get Bits To track$
         ReDim D(TrackW-1,TrackH-1) As Long At StrPtr(track$) + 8
         Graphic Set Pos (100,25) : Graphic Print "Draw track with left mouse."
         Graphic Set Pos (100,50) : Graphic Print "Erase track with right mouse."
         NewSprite : DrawSprite
         LastX = -1
         SetMenusAndToolbar
      Case %WM_Size
         Dialog Get Client hDlg To GraphicW,GraphicH
         GraphicH -= 60
         Control Set Client hDlg, %IDC_Graphic, GraphicW, GraphicH
         SetCutOffValues
      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         Graphic Set Bits track$
         Graphic ReDraw
         Graphic Save $SessionImage   'large file, decided not to save
         Settings_INI "save"
      Case %WM_Timer
         'QueryPerformanceCounter   qStart
         For i = 0 To 4
            Graphic Set Bits track$
            MoveSprite
            If DrawSprite Then Exit For
         Next i
         'QueryPerformanceCounter   qStop
         'Dialog Set Text hDlg, "gbRider   v" + $ver + "      Frame Speed: " +  Format$((qStop-qStart)/qFreq,"0.000") & " seconds"
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_Open : SelectAndOpenTrack
            Case %IDT_Save : SaveTrack
            Case %IDT_New  : NewGame

            Case %IDT_Reset
               KillTimer hDlg, %ID_Timer
               Power = 0 : SetMenusAndToolbar
               Graphic Set Bits track$
               ResetSprite

            Case %IDT_Power
               Power Xor= 1
               If Power=1 Then SetTimer hDlg, %ID_Timer, TimerInterval, 0
               If Power=0 Then KillTimer hDlg, %ID_Timer

            Case %IDT_Step
               If Power = 0 Then
                  Graphic Set Bits track$ : MoveSprite : DrawSprite
               End If

            Case %IDT_ZoomOut
               ZoomOut Xor= 1
               If ZoomOut Then
                  DrawSprite
               Else
                  KillTimer hDlg, %ID_Timer
                  Power = 0 : SetMenusAndToolbar
                  Graphic Set Bits track$
                  ResetSprite
               End If
               SetCutOffValues

            Case %IDT_Copy      : Clipboard Reset : Clipboard Set Bitmap hGraphic

            Case %IDT_Help      : iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbrider.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_OutOfSight
               OutOfSight Xor= 1 : SetMenusAndToolbar : SetCutoffValues

            Case %IDM_BGColor
               j = BGColor
               BGColor = SelectColor(BGColor)
               Graphic Color TrackColor, BGColor
               For y = 0 To TrackH-1
                  For x = 0 To TrackW-1
                     If D(x,y) =  Bgr(j) Then D(x,y) = Bgr(BGColor)
                  Next x
               Next Y
               Graphic Set Bits Track$
               DrawSprite
               Graphic ReDraw

            Case %IDM_TrackColor
               j = TrackColor
               TrackColor = SelectColor(TrackColor)
               Graphic Color TrackColor, BGColor
               For y = 0 To TrackH-1
                  For x = 0 To TrackW-1
                     If D(x,y) = Bgr(j) Then D(x,y) = Bgr(TrackColor)
                  Next x
               Next Y
               Graphic Set Bits track$
               DrawSprite

            Case %IDM_DefaultColors
               w = TrackColor  'temp use
               h = BGColor
               TrackColor = %Red : BGColor = %White
               Graphic Color TrackColor, BGColor
               For y = 0 To TrackH-1
                  For x = 0 To TrackW-1
                     If D(x,y) = Bgr(w) Then D(x,y) = Bgr(TrackColor)
                     If D(x,y) = Bgr(h) Then D(x,y) = Bgr(BGColor)
                  Next x
               Next Y
               Graphic Set Bits track$
               DrawSprite

            Case %IDM_AllowUnder
               AllowUnder Xor= 1
               SetMenusAndToolbar

         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_New To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_New        : @PTT.@lpszText = "Clear the Screen - Path and Rider"
                        Case %IDT_Reset      : @PTT.@lpszText = "Move Rider to Start of Path"
                        Case %IDT_Power      : @PTT.@lpszText = "Start/Stop Animation"
                        Case %IDT_Step       : @PTT.@lpszText = "Step Through One s.ycle of Animation"
                        Case %IDT_Copy       : @PTT.@lpszText = "Copy Image to Clipboard"
                        Case %IDT_Settings   : @PTT.@lpszText = "Settings"
                        Case %IDT_Help       : @PTT.@lpszText = "Open Online Help Page"
                        Case %IDT_ZoomOut    : @PTT.@lpszText = "Open Zoom Out Dialog to See Entire Track"
                     End Select
               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
         End Select
      Case %WM_RButtonDown
         If Power = 0 Then
            Eraser = 1
            Graphic Width EraseWidth
            SetCapture hDlg    'start capturing, so can detect LButtonUp when it occurs
         End If
      Case %WM_LButtonDown
         If Power = 0 Then
            Graphic Width LineWidth
            SetCapture hDlg    'start capturing, so can detect LButtonUp when it occurs
         End If
      Case %WM_MouseMove
         If GetCapture() = hDlg Then   'app has capture    'why?
            x = Lo(Integer,Cb.LParam)
            y = Hi(Integer,Cb.LParam)- 60
            If LastX = -1 Then LastX = x : LastY = y
            Graphic Line (LastX,LastY)-(x,y), IIf(Eraser,BGColor,TrackColor)
            LastX = x : LastY = y
            Graphic ReDraw
         End If
      Case %WM_RButtonUp
         If Power = 0 Then
            Eraser = 0
            Graphic Width LineWidth
            ReleaseCapture
            LastX = -1
            If (s.x=s.w/2) And (s.y=s.h) Then Graphic Box (0,0)-(s.w,s.h),,BGcolor,BGColor
            Graphic Get Bits To track$
            ReDim D(TrackW-1,TrackH-1) As Long At StrPtr(track$) + 8
         End If
      Case %WM_LButtonUp
         If Power = 0 Then
            ReleaseCapture
            LastX = -1
            Graphic Box (0,0)-(s.w,s.h),,BGcolor,BGColor
            Graphic Get Bits To track$
            ResetSprite
            ReDim D(TrackW-1,TrackH-1) As Long At StrPtr(track$) + 8
         End If
   End Select
End Function


Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Power, IIf(Power,%TBState_Checked,0) Or %TBState_Enabled
   'Menus
    Menu Set State hSettings, ByCmd %IDM_OutOfSight, IIf(OutOfSight,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AllowUnder, IIf(AllowUnder,%MFS_Checked,0) Or %MFS_Enabled
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,50 To hImageList
    ImageList Add Icon hImageList, "xnew"       '1
    ImageList Add Icon hImageList, "xreset"     '2
    ImageList Add Icon hImageList, "xpower"     '3
    ImageList Add Icon hImageList, "xstep"      '4
    ImageList Add Icon hImageList, "xcopy"      '5
    ImageList Add Icon hImageList, "xsettings"  '6
    ImageList Add Icon hImageList, "xhelp"      '7
    ImageList Add Icon hImageList, "xopen"      '8
    ImageList Add Icon hImageList, "xsave"      '9
    ImageList Add Icon hImageList, "xzoom"     '10

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Open, %BTNS_Button, "Open"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Save, %BTNS_Button, "Save"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_New, %BTNS_Button, "New"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Power,  %BTNS_Check, "Play"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Step,  %BTNS_Button, "Step"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Reset, %BTNS_Button, "Reset"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Copy,  %BTNS_Button, "Copy"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_ZoomOut,  %BTNS_Check, "Zoom"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Help,  %BTNS_Button, "Help"

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Background Color", %IDM_BGColor, %MF_Enabled
    Menu Add String, hSettings, "Line Color", %IDM_TrackColor, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Default Colors", %IDM_DefaultColors, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Reset Sprite When Out of Sight", %IDM_OutofSight, %MF_Enabled
    Menu Add String, hSettings, "Allow Rider Under the Track", %IDM_AllowUnder, %MF_Enabled

End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "600", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "tracks\empty.trk", FileName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "SpriteColor", Str$(%Blue), temp, %Max_Path, INIFileName:  SpriteColor = Val(temp)
      Getprivateprofilestring "All", "TrackColor", Str$(%Red), temp, %Max_Path, INIFileName:  TrackColor = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%White), temp, %Max_Path, INIFileName:  BGColor = Val(temp)
      Getprivateprofilestring "All", "RiderX", "35", temp, %Max_Path, INIFileName:  RiderX = Val(temp)
      Getprivateprofilestring "All", "RiderY", "35", temp, %Max_Path, INIFileName:  RiderY = Val(temp)
      Getprivateprofilestring "All", "TimerInterval", "30", temp, %Max_Path, INIFileName:  TimerInterval = Val(temp)
      Getprivateprofilestring "All", "LineWidth", "10", temp, %Max_Path, INIFileName:  LineWidth = Val(temp)
      Getprivateprofilestring "All", "EraseWidth", "40", temp, %Max_Path, INIFileName:  EraseWidth = Val(temp)
      Getprivateprofilestring "All", "TrackW", "1200", temp, %Max_Path, INIFileName:  TrackW = Val(temp)
      Getprivateprofilestring "All", "TrackH", "1200", temp, %Max_Path, INIFileName:  TrackH = Val(temp)
      Getprivateprofilestring "All", "OutOfSight", "1", temp, %Max_Path, INIFileName:  OutOfSight = Val(temp)
      Getprivateprofilestring "All", "AllowUnder", "0", temp, %Max_Path, INIFileName:  AllowUnder = Val(temp)
      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "SpriteColor", Str$(SpriteColor), INIFileName
      WritePrivateProfileString "All", "TrackColor", Str$(TrackColor), INIFileName
      WritePrivateProfileString "All", "BGColor", Str$(BGColor), INIFileName
      WritePrivateProfileString "All", "RiderX", Str$(RiderX), INIFileName
      WritePrivateProfileString "All", "RiderY", Str$(RiderY), INIFileName
      WritePrivateProfileString "All", "TimerInterval", Str$(TimerInterval), INIFileName
      WritePrivateProfileString "All", "LineWidth", Str$(LineWidth), INIFileName
      WritePrivateProfileString "All", "EraseWidth", Str$(EraseWidth), INIFileName
      WritePrivateProfileString "All", "TrackW", Str$(TrackW), INIFileName
      WritePrivateProfileString "All", "TrackH", Str$(TrackH), INIFileName
      WritePrivateProfileString "All", "OutOfSight", Str$(OutOfSight), INIFileName
      WritePrivateProfileString "All", "AllowUnder", Str$(AllowUnder), INIFileName
      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(2)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_C  : ac(c).cmd   = %IDT_Copy       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDT_New        : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateGraphic
   Control Add Graphic, hDlg, %IDC_Graphic,"", 0,60,400,400
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Set Overlap %True
   Graphic Set Virtual TrackW, TrackH
   Graphic Get DC To hGraphicDC
   Graphic Set Mix %R2_CopyPen
   Graphic Color TrackColor, BGColor
   Graphic Clear
End Sub

Sub LoadSessionImage
   Local hBMP As Dword
   Graphic Bitmap Load $SessionImage, 0, 0 To hBMP
   Graphic Copy hBMP, 0
   Graphic Attach hBMP,0
   Graphic Bitmap End
End Sub

Sub NewSprite
   s.x = s.w \ 2
   s.y = 20
   s.xvel = 0
   s.yvel = 0
   s.x = s.h/2
   s.y = s.h
End Sub

Sub LoadImageToMemoryBitmap (ImgName As String, hWin As Dword, w As Long, h As Long, hDC As Dword)
   Local pGraphics,pImage,token As Dword, StartupInput As GdiplusStartupInput

   'initialize GDI
   StartupInput.GdiplusVersion = 1                    'initialize GDIPlus
   GdiplusStartup(token, StartupInput, ByVal %NULL)   'initialize GDIPlus

   GdipLoadImageFromFile((ImgName), pImage)           'load image
   GdipGetImageWidth(pImage,w)                        'get width
   GdipGetImageHeight(pImage, h)                      'get height

   Graphic Bitmap New w,h To hWin
   Graphic Attach hWin, 0
   Graphic Get DC To hDC

   GdipCreateFromHDC(hDC, pGraphics)                  ' Create the Graphic object
   GdipDrawImage(pGraphics, pImage, 0, 0)             ' Draw the image

   'shutdown GDI
   If pImage Then GdipDisposeImage(pImage)            'cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
   GdiplusShutdown token                              'shutdown GDI+
End Sub

Sub CreateRotationBitmap
   'rotation bitmpa
   RW = 1.5 * s.w : RH = 1.5 * s.h
   Graphic Bitmap New RW,RH To hBMPR
   Graphic Attach hBMPR, 0
   Graphic Color %Black, %Black
   Graphic Get DC To hDCR
End Sub

Sub SaveTrack
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, temp$
    filter$ = "gbRider Track (*.trk)" + $Nul + "*.trk" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_PathMustExist Or %OFN_OverWritePrompt
    defaultext$ = "trk"
    Display Savefile hDlg, 100, 100, "Save Track to File", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Open filevar$ For Output As #1
       Print #1, track$;
       Close #1
    End If
End Sub

Function SelectAndOpenTrack As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "gbRider Track (*.trk)" + $Nul + "*.trk" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Open FileName For Binary As #1
       Get$ #1, Lof(1), track$
       Close #1
       KillTimer hDlg, %ID_Timer
       Power = 0 : SetMenusAndToolbar
       Graphic Set Bits track$
       ReDim D(TrackW-1,TrackH-1) As Long At StrPtr(track$) + 8
       NewSprite : DrawSprite
       Graphic ReDraw
    End If
End Function

Sub SetCutoffValues
   If ZoomOut Or (OutOfSight=0) Then
      CutOffX = TrackW - s.w
      CutOffY = TrackH - s.h
   Else
      CutOffX = GraphicW + s.w
      CutoffY = GraphicH + s.h
   End If
End Sub

Sub NewGame
   KillTimer hDlg, %ID_Timer
   Power = 0 : SetMenusAndToolbar
   Graphic Clear
   Graphic Get Bits To track$
   ReDim D(TrackW-1,TrackH-1) As Long At StrPtr(track$) + 8
   ResetSprite
End Sub

Sub ResetSprite
   Local i As Long
   s.x = s.w / 2 : s.y = s.h : s.xvel = 400 : s.yvel = 400             'new sprite
   For i = 0 To UBound(HSX) : HSX(i) = s.x : HSY(i) = s.y : Next i     'history
   TransparentBlt hGraphicDC,0,0,s.w,s.h,s.DC,0,0,s.w,s.h,%Black
   If ZoomOut Then
      Graphic Stretch hDlg, %IDC_Graphic, (0,0)-(TrackW-1,TrackH-1) To (200,1)-(399,101), %Mix_CopySrc, %HalfTone
      Graphic Width 1
      Graphic Box (199,0)-(400,102),,%Black
   End If
   Graphic ReDraw
End Sub

Sub MoveSprite
   If (D(s.x+1,s.y)=Bgr(TrackColor))   And (D(s.x+1,s.y-1)=Bgr(TrackColor)) And (D(s.x,s.y-1)<>Bgr(TrackColor)) Then Decr s.y           : Rule = 6 : Exit Sub
   If (D(s.x+1,s.y)=Bgr(TrackColor))   And (D(s.x+1,s.y-1)<>Bgr(TrackColor))                            Then Incr s.x : Decr s.y        : Rule = 7 : Exit Sub
   If (D(s.x,s.y-1)=Bgr(TrackColor))   And (D(s.x-1,s.y-1)<>Bgr(TrackColor))                            Then Decr s.x : Decr s.y        : Rule = 8 : Exit Sub
   If (D(s.x,s.y-1)=Bgr(TrackColor))   And (D(s.x-1,s.y-1)=Bgr(TrackColor)) And (D(s.x-1,s.y)<>Bgr(TrackColor)) Then Decr s.x           : Rule = 9 : Exit Sub

   If AllowUnder Then
      If (D(s.x-1,s.y-1)=Bgr(TrackColor)) And (D(s.x-1,s.y)=Bgr(TrackColor)) And (D(s.x-1,s.y+1)<>Bgr(TrackColor)) Then Decr s.x : Incr s.y: Rule = 10: Exit Sub
      If (D(s.x-1,s.y)=Bgr(TrackColor))   And (D(s.x-1,s.y+1)=Bgr(TrackColor)) And (D(s.x,s.y+1)<>Bgr(TrackColor)) Then Incr s.y           : Rule = 11: Exit Sub
   End If

   If D(s.x,s.y+1) <> Bgr(TrackColor)   Then Incr s.y            : Rule = 1 : Exit Sub
   If D(s.x+1,s.y+1) <> Bgr(TrackColor) Then Incr s.x : Incr s.y : Rule = 2 : Exit Sub
   If D(s.x+1,s.y) <> Bgr(TrackColor)   Then Incr s.x            : Rule = 3 : Exit Sub
   If D(s.x+1,s.y-1) <> Bgr(TrackColor) Then Incr s.x : Decr s.y : Rule = 4 : Exit Sub
   If D(s.x,s.y-1) <> Bgr(TrackColor)   Then Decr s.y            : Rule = 5 : Exit Sub

End Sub

Function DrawSprite() As Long
   'boundary check
   s.x = Max(1,s.x) : Array Insert HSX(), s.x
   s.y = Max(1,s.y) : Array Insert HSY(), s.y
   If (s.x > CutOffX-2) Or (s.y > CutOffY-2) Then
      KillTimer hDlg, %ID_Timer
      Power = 0 : SetMenusAndToolbar
      ResetSprite
      Function = 1
   Else
'      TransparentBlt hGraphicDC,s.x-s.w/2,s.y-s.h,s.w,s.h,s.DC,0,0,s.w,s.h,%Black  'draw
'      Graphic Set Pixel (s.x,s.y), %Green
      ShowRotatedSprite
      If ZoomOut Then
         Graphic Stretch hDlg, %IDC_Graphic, (0,0)-(TrackW-1,TrackH-1) To (200,1)-(399,101), %Mix_CopySrc, %HalfTone
         Graphic Width 1
         Graphic Box (199,0)-(400,102),,%Black
      End If
      Graphic ReDraw
   End If
End Function


Function ATN2 (ByVal Y As Ext,ByVal X As Ext) As Ext
  #Register None
  Dim Res As Ext

  !fld y##    ;Get y onto the FPU stack
  !fld x##    ;Get x onto the FPU stack
  !fpatan     ;Get the ATAN(y/x), Put result In ST(1) Then pop the stack
  !fstp res##   ;store the result In res## And pop the stack

  Function = Res
End Function

Sub ThetaInsert(t As Single)
   s.ts(5) = s.ts(4)
   s.ts(4) = s.ts(3)
   s.ts(3) = s.ts(2)
   s.ts(2) = s.ts(1)
   s.ts(1) = s.ts(0)
   s.ts(0) = t
End Sub

Sub ShowRotatedSprite
   Local i,x,y,XCenter, YCenter, dxr, dyr As Long, tempTheta As Single
   Dim PlgPts(0 To 2) As PointAPI

   'rotation effect on
   If Rule <> 1 Then s.t = atn2(HSY(0)-HSY(5), HSX(0)-HSX(5))

   ThetaInsert s.t
   For i = 0 To 5 : tempTheta += s.ts(i) : Next i
   s.t = tempTheta / 6

   dxr -= s.h/2 * Sin(s.t)
   dyr -= s.h/2 * (1 - Cos(s.t))

   'rotation of original bitmap to a temporary memory bitmap
   XCenter = s.w/2 : YCenter = s.h/2
   x = 0 : y = 0   'point in original bitmap
   PlgPts(0).X = XCenter + (x - XCenter) * Cos(s.t) - (y - YCenter) * Sin(s.t)  'upper-left in target
   PlgPts(0).Y = YCenter + (x - XCenter) * Sin(s.t) + (y - YCenter) * Cos(s.t)
   x = s.w : y = 0   'point in original bitmap
   PlgPts(1).X = XCenter + (x - XCenter) * Cos(s.t) - (y - YCenter) * Sin(s.t)  'upper-right in target
   PlgPts(1).Y = YCenter + (x - XCenter) * Sin(s.t) + (y - YCenter) * Cos(s.t)
   x = 0 : y = s.h   'point in original bitmap
   PlgPts(2).X = XCenter + (x - XCenter) * Cos(s.t) - (y - YCenter) * Sin(s.t)  'lower left in target
   PlgPts(2).Y = YCenter + (x - XCenter) * Sin(s.t) + (y - YCenter) * Cos(s.t)
   Graphic Attach hBMPR, 0
   Graphic Clear
   PlgBlt(hDCR, PlgPts(0), s.DC, 0, 0, s.w, s.h, 0&, 0, 0)  ' Draw rotated image

   'place rotated bitmap into the main graphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   TransparentBlt hGraphicDC,s.x-s.w/2-dxr,s.y-s.h-dyr,RW,RH,hDCR,0,0,RW,RH,%Black
End Sub
